import java.applet.Applet;
import java.awt.*;
import java.awt.event.*;
import java.applet.*;
import java.awt.geom.*;
import java.math.*;


public class DrawMyStuff implements Runnable {
    PictureCanvas P;

    /**This is the general method for creating on of these objects.*/
    public DrawMyStuff() {
    }

    /**This method calls the object and assigns to it a PictureCanvas.
       As this object runs, it modifies the colors on the Picture Canvas.*/

    public DrawMyStuff(PictureCanvas PP) {
	this.P =PP;
    }


    /**Main routine*/
    public void run() {
	int i=0;
	int j=0; 

	/**This is the background color*/
	int[] b={80,100,120};

	/**It is convenient to think about colors in terms of their RGB
           components, which have range {0-255,0-255,0-255}.  But then,
           the image drawer works with single integers which have this
           same information.  So, the routine convert converts from the
           RGB format to a single integer.*/

	int bg=convert(b);

	/**This loop cycles through the 400x400 grid of pixels.
           Notice that the 400,400 here matches the same bounds
           in the PictureCanvas. I think that this match is important.*/

	while(true) {
	    ++i;
            if(i==400) {
                i=0;++j;
	    }
	    if(j==400) {
		i=0;j=0;
	        P.repaint();
	    }

	    /**Here is what is done for each pixel:*/

	    /**The picture canvas is scaled by a certain amount, and
               the (i,j)th pixel corresponds to some complex number.
               When you click on the picture canvas, this changes.*/

	    Complex z=P.unTransform(i,j);

	    /**Tests if the point is in the unit square.*/

	    boolean test=inUnitSquare(z);

	    /**If not, just draw the background color*/

	    if(test==false) P.IMAGE.setRGB(i,j,bg); 

	    /**If so, then ...*/

	     if(test==true) {

		 /**specify an RGB value based on the position.*/
                int[] c={(int)(255*z.x),0,(int)(255*z.y)};

		/**do the conversion*/
		int col=convert(c);

		/**modify the pixel*/
		P.IMAGE.setRGB(i,j,col);
	    }
	}
    }

    /**Tests if you are in the unit square*/
    public static boolean inUnitSquare(Complex z) {
	double[] d={z.x,z.y};
	 if(d[0]<=0) return(false);
	 if(d[0]>=1) return(false);
	 if(d[1]<=0) return(false);
	 if(d[1]>=1) return(false);
	return(true);
    }

    /**Coloring: This converts a list of 3 numbers 
       (redval,blueval,greenval)
       into a single integer.*/

    public static int convert(int[] a) {
	int n=256*256*a[0]+256*a[1]+a[2];
	return(n);
    }


}


